"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _button = require("antd-mobile/lib/button");

var _button2 = _interopRequireDefault(_button);

var _navBar = require("antd-mobile/lib/nav-bar");

var _navBar2 = _interopRequireDefault(_navBar);

var _icon = require("antd-mobile/lib/icon");

var _icon2 = _interopRequireDefault(_icon);

var _toast = require("antd-mobile/lib/toast");

var _toast2 = _interopRequireDefault(_toast);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

require("antd-mobile/lib/button/style/css");

require("antd-mobile/lib/nav-bar/style/css");

require("antd-mobile/lib/icon/style/css");

require("antd-mobile/lib/toast/style/css");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactStarRatingComponent = require("react-star-rating-component");

var _reactStarRatingComponent2 = _interopRequireDefault(_reactStarRatingComponent);

var _AttUtil = require("../AttUtil/AttUtil");

var _AttUtil2 = _interopRequireDefault(_AttUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SignCanvas = function (_Component) {
  (0, _inherits3.default)(SignCanvas, _Component);

  function SignCanvas() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, SignCanvas);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = SignCanvas.__proto__ || Object.getPrototypeOf(SignCanvas)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      originStarData: 0,
      originSignData: '',
      starData: 0,
      signData: ''
    }, _this.initialCanvas = function () {
      var signCanvas = _this.refs.signCanvas;

      var ctx = signCanvas.getContext("2d");
      signCanvas.width = signCanvas.width;
      // 如果signDatas有值，则显示
      var signData = _this.state.signData;

      if (signData) {
        var imgObj = new Image();
        imgObj.src = _AttUtil2.default.PIC_PREFIX + signData;
        //待图片加载完后，将其显示在canvas上
        imgObj.onload = function () {
          //this即是imgObj,保持图片的原始大小：470*480
          ctx.drawImage(imgObj, 0, 0);
        };
      }
      ctx.strokeStyle = 'Black';
      ctx.lineWidth = 1;
      var drawer = {
        isDrawing: false,
        touchstart: function touchstart(coors) {
          ctx.beginPath();
          ctx.moveTo(coors.x, coors.y);
          drawer.isDrawing = true;
        },
        touchmove: function touchmove(coors) {
          if (drawer.isDrawing) {
            ctx.lineTo(coors.x, coors.y);
            ctx.stroke();
          }
        },
        touchend: function touchend(coors) {
          if (drawer.isDrawing) {
            drawer.touchmove(coors);
            drawer.isDrawing = false;
          }
        }
      };
      var draw = function draw(event) {
        if (!event.targetTouches[0]) {
          ctx.closePath();
          drawer.isDrawing = false;
          return;
        }
        var coors = {
          x: event.targetTouches[0].pageX,
          y: event.targetTouches[0].pageY
        };
        var obj = signCanvas;
        if (obj.offsetParent) {
          do {
            coors.x -= obj.offsetLeft;
            coors.y -= obj.offsetTop;
          } while ((obj = obj.offsetParent) != null);
        }
        drawer[event.type](coors);
      };
      signCanvas.addEventListener('touchstart', draw, false);
      signCanvas.addEventListener('touchmove', draw, false);
      signCanvas.addEventListener('touchend', draw, false);
      signCanvas.addEventListener('touchmove', function (event) {
        event.preventDefault();
      }, false);
    }, _this.showCanvas = function () {
      var signature = _this.refs.signature;

      _this.initialCanvas();
      signature.style.animation = 'signature_appear 0.4s linear';
      signature.style.display = 'block';
    }, _this.hideCanvas = function () {
      var signature = _this.refs.signature;

      signature.style.display = 'none';
    }, _this.save = function () {
      var signCanvas = _this.refs.signCanvas;
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          useStar = _this$props.useStar;
      var starData = _this.state.starData;

      if (useStar && !starData) {
        _toast2.default.info("\u8BF7\u8FDB\u884C\u5BA2\u6237\u8BC4\u4EF7", _AttUtil2.default.TOAST_DURATION);
        return;
      }
      var signData = signCanvas.toDataURL("image/png");
      var index = signData.lastIndexOf("base64");
      var signBase64 = signData.substring(index + 7, signData.length);
      _this.setState({
        originStarData: starData,
        originSignData: signBase64,
        signData: signBase64
      });
      _this.hideCanvas();
      onChange ? onChange(false, signBase64, starData) : '';
    }, _this.clear = function () {
      var _this$state = _this.state,
          signData = _this$state.signData,
          starData = _this$state.starData;

      _this.setState({
        originStarData: starData,
        originSignData: signData,
        starData: 0,
        signData: ''
      });
      var signCanvas = _this.refs.signCanvas;

      signCanvas.width = signCanvas.width;
    }, _this.back = function () {
      var _this$state2 = _this.state,
          originStarData = _this$state2.originStarData,
          originSignData = _this$state2.originSignData;
      var onChange = _this.props.onChange;
      var signature = _this.refs.signature;

      signature.style.display = 'none';
      _this.setState({
        starData: originStarData,
        signData: originSignData
      });
      onChange(false);
      _this.hideCanvas();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(SignCanvas, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _props = this.props,
          signs = _props.signs,
          stars = _props.stars;

      this.setState({
        originStarData: stars || 0,
        originSignData: signs || '',
        signData: signs,
        starData: stars
      });
    }

    //初始化画布


    //显示画布


    //隐藏画布


    //保存签字内容


    //清楚签字内容


    //返回

  }, {
    key: "onStarClick",


    //星级点击事件
    value: function onStarClick(nextValue) {
      this.setState({
        starData: nextValue
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var isSigning = this.props.isSigning;

      var wasSigning = prevProps.isSigning;
      if (!wasSigning && isSigning) {
        isSigning ? this.showCanvas() : this.hideCanvas();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var starData = this.state.starData;
      var useStar = this.props.useStar;

      return _react2.default.createElement(
        "div",
        { ref: "signature", className: "zk_attachments_signature" },
        _react2.default.createElement(
          _navBar2.default,
          {
            mode: "dark",
            icon: _react2.default.createElement(_icon2.default, { type: "left", size: "lg" }),
            leftContent: '返回',
            onLeftClick: this.back
          },
          "\u7B7E\u5B57"
        ),
        useStar ? _react2.default.createElement(
          "div",
          { className: 'zk_attachments_star' },
          _react2.default.createElement(
            "div",
            null,
            "\u5BA2\u6237\u8BC4\u4EF7"
          ),
          _react2.default.createElement(_reactStarRatingComponent2.default, {
            name: "attachments-starRating",
            starCount: 5,
            value: starData,
            onStarClick: function onStarClick(nextValue) {
              _this2.onStarClick(nextValue);
            }
          })
        ) : '',
        _react2.default.createElement("canvas", { width: window.screen.width, height: document.body.scrollHeight - 95 - (useStar ? 45 : 0),
          ref: "signCanvas" }),
        _react2.default.createElement(
          _button2.default,
          { className: 'zk_attachments_foot', onClick: function onClick() {
              _this2.clear();
            } },
          "\u6E05 \u9664"
        ),
        _react2.default.createElement(
          _button2.default,
          { className: 'zk_attachments_foot', type: 'primary', onClick: function onClick() {
              _this2.save();
            } },
          "\u4FDD \u5B58"
        )
      );
    }
  }]);
  return SignCanvas;
}(_react.Component);

exports.default = SignCanvas;
//# sourceMappingURL=SignCanvas.js.map