/* 基础卡片 */
import React, {Component} from 'react'
import PropTypes from 'prop-types'
import {Card as AntdCard, WingBlank, WhiteSpace} from 'antd-mobile';
import './BaseCard.scss'

class BaseCard extends Component {
  constructor(props) {
    super(props);
  }

  setBgColor(index) {
    const {bgColorArr} = this.props;
    let color = [];
    return bgColorArr ? bgColorArr[index] : color[index];
  }

  render() {
    const {header, body, bodyExtra, footer, onClick, children, className} = this.props;
    let cardClass = className ? `zk_basecard ${className}` : 'zk_basecard';
    return (
      <div className={cardClass}>
        <WingBlank size="lg">
          <WhiteSpace size="lg"/>
          <AntdCard onClick={onClick}>
            {header ? <AntdCard.Header className={'zk_basecard-hd'} title={header}
                                       style={{backgroundColor: this.setBgColor(0)}}/> : ''}
            <AntdCard.Body>
              <div className={'zk_basecard-body'} style={{backgroundColor: this.setBgColor(1)}}>
                <div>{children || body}</div>
                {bodyExtra ? <div className={'zk_basecard-bodyextra'}>{bodyExtra}</div> : ''}
              </div>
            </AntdCard.Body>
            {footer ? <AntdCard.Footer className={'zk_basecard-ft'}
                                       style={{backgroundColor: this.setBgColor(2)}}
                                       content={footer}/> : ''}
          </AntdCard>
          <WhiteSpace size="lg"/>
        </WingBlank>
      </div>
    );
  }
}

BaseCard.propTypes = {
  //填充背景数据集合
  bgColorArr: PropTypes.array,
  header: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
  body: PropTypes.element,
  bodyExtra: PropTypes.element,
  footer: PropTypes.element,
  className: PropTypes.string
};

export default BaseCard;
