/* 头部组件 */
import React, {Component} from 'react'
import PropTypes from 'prop-types'
import './Header.scss'

export class Header extends Component {
  getClassName = () => {
    const {size, overflow} = this.props;
    let className = '';
    switch (size) {
      case 'big':
        className = 'zk_h_big';
        break;
      case 'middle':
        className = 'zk_h_middle';
        break;
      case 'small':
        className = 'zk_h_small';
        break;
      default:
        className = 'zk_h_default';
    }
    if (overflow) {
      className += ' zk_header_overflow_ellipsis';
    }
    return className;
  }

  render() {
    const {title, extra, color, bgColor, padding} = this.props;
    return (
      <div className={'zk_header'} style={{backgroundColor: bgColor, padding: padding}}>
        <h1 className={this.getClassName()} style={{color: color}}>{title}</h1>
        {extra ? <div>{extra}</div> : ''}
      </div>
    );
  }
}

Header.propTypes = {
  title: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
  color: PropTypes.string,
  size: PropTypes.oneOf(['big', 'middle', 'small']),
  overflow: PropTypes.bool,
  bgColor: PropTypes.string,
  padding: PropTypes.string,
  extra: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
};
